/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PelvicVasculatureAnatomicalLocation;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_PelvicVasculatureAnatomicalLocation;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents PelvicVasculatureAnatomicalLocation CID12140
 */
public class PelvicVasculatureAnatomicalLocation_CID12140 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new PelvicVasculatureAnatomicalLocation_CID12140 Template 
	 */
	public PelvicVasculatureAnatomicalLocation_CID12140()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumPelvicVasculatureAnatomicalLocation Object of EnumCM_PelvicVasculatureAnatomicalLocation represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_PelvicVasculatureAnatomicalLocation enumPelvicVasculatureAnatomicalLocation)
	{
		switch(enumPelvicVasculatureAnatomicalLocation) 
		{
		case UMBILICAL_ARTERY: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.UMBILICAL_ARTERY_T_F1810.getValue(); break;
		case UMBILICAL_VEIN: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.UMBILICAL_VEIN_T_F1820.getValue(); break;
		case OVARIAN_ARTERY: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.OVARIAN_ARTERY_T_46980.getValue(); break;
		case OVARIAN_VEIN: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.OVARIAN_VEIN_T_48780.getValue(); break;
		case UTERINE_ARTERY: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.UTERINE_ARTERY_T_46820.getValue(); break;
		case UTERINE_VEIN: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.UTERINE_VEIN_T_49010.getValue(); break;
		case VITELLINE_ARTERY_OF_PLACENTA: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.VITELLINE_ARTERY_OF_PLACENTA_T_F1412.getValue(); break;
		case VITELLINE_VEIN_OF_PLACENTA: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.VITELLINE_VEIN_OF_PLACENTA_T_F1413.getValue(); break;
		case COMMON_ILIAC_ARTERY: this.strCodeValue =EnumCV_PelvicVasculatureAnatomicalLocation.COMMON_ILIAC_ARTERY_T_46710.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumPelvicVasculatureAnatomicalLocation Object of EnumCM_PelvicVasculatureAnatomicalLocation represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_PelvicVasculatureAnatomicalLocation enumPelvicVasculatureAnatomicalLocation)
	{
		switch(enumPelvicVasculatureAnatomicalLocation)
		{
		case UMBILICAL_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.UMBILICAL_ARTERY.getSNOMEDCTID(); break;
		case UMBILICAL_VEIN : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.UMBILICAL_VEIN.getSNOMEDCTID(); break;
		case OVARIAN_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.OVARIAN_ARTERY.getSNOMEDCTID(); break;
		case OVARIAN_VEIN : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.OVARIAN_VEIN.getSNOMEDCTID(); break;
		case UTERINE_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.UTERINE_ARTERY.getSNOMEDCTID(); break;
		case UTERINE_VEIN : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.UTERINE_VEIN.getSNOMEDCTID(); break;
		case VITELLINE_ARTERY_OF_PLACENTA : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.VITELLINE_ARTERY_OF_PLACENTA.getSNOMEDCTID(); break;
		case VITELLINE_VEIN_OF_PLACENTA : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.VITELLINE_VEIN_OF_PLACENTA.getSNOMEDCTID(); break;
		case COMMON_ILIAC_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.COMMON_ILIAC_ARTERY.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for PelvicVasculatureAnatomicalLocation
	 * @param enumPelvicVasculatureAnatomicalLocation Object of EnumCM_PelvicVasculatureAnatomicalLocation.
	 */
	public void setPelvicVasculatureAnatomicalLocation(EnumCM_PelvicVasculatureAnatomicalLocation enumPelvicVasculatureAnatomicalLocation)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumPelvicVasculatureAnatomicalLocation.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumPelvicVasculatureAnatomicalLocation);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumPelvicVasculatureAnatomicalLocation);
	}
}
